/* (New) Standard internal bitmap and font format.
 * Per Bothner, April 1985.
 * Still not 100% finalized; concact me of you use this file.
 */

#define Scaled long	/* fixpoint number with 16 bits of fraction */

typedef struct
  {
    short v;	/* row number: going down with increasing v */
    short h;	/* column number: going right with increasing h */
  } Vector;

typedef struct { Scaled v, h;} ScaledVector;

typedef struct Rectangle
  {
    Vector start;
    Vector size;
  } Rectangle;

#define u_char unsigned char
#define u_short unsigned short
typedef u_char BitUnit;		/* a BitUnit is the "primitive" bitstring */
typedef u_short BitWord;	/* minimum bitstring allocation unit */
#define BitUnitLog 3		/* log2 of length of BitUnit in bits */
#define BitUnitLen (1<<BitUnitLog) /* # of bits in a BitUnit */
#define BitAlignLog 1		/* log2 of BitWord/BitUnit ratio */
#define BitAlign (1<<BitAlignLog) /* # of BitUnits to a BitWord */
#define BitWordLen (BitUnitLen*BitAlign) /* # of bits in a BitWord */
#define BitWordLog (BitUnitLog+BitAlignLog) /* log2 of BitWordLen */
#define BitWordOnes 0xFFFF	/* a BitWord full of ones */

#ifdef MC68000
typedef struct TypeOb *
    HeapPrefix;
#else
typedef struct {
    short options;
    short refCount;
    struct TypeOb *type;
  } HeapPrefix;
#endif

typedef struct CharPrefix
  {
    /* short ascent = height above baseline = origin.v */
    Vector origin;		/* origin relative to bounding box top left */
    ScaledVector width;		/* displacement vector */
    BitUnit *start;		/* pointer to first word */
    short xoffset;		/* distance from HeadRaster left edge */
    u_short stride;		/* in terms of BitUnit units */
    Vector bBox;		/* size of bounding box in pixels */
    HeapPrefix type;		/* optional pointer to type descriptor */
  } VRaster;
