#include "cal.h"

OpenCalendar( Table, msg, id )
NameTable Table;
Message msg;
ProcessId id;
  {
    int i;
    CalendarRequest *request = (CalendarRequest *) msg;
    CalendarReply *reply = (CalendarReply *) msg;
    
    char name[NAME_LEN];
    SystemCode force, MoveFrom();
    
    force = request->requestcode & FORCE;  
    if (MoveFrom( id, name, request->name, NAME_LEN ) != OK)
      {
        reply->replycode = BAD_ARGS;
	return;
      }
        
    i = 0;
    
    while ( i < MAX_NAMES && Table[i].name[0] != 0)
      {
        if (!strcmp(Table[i].name,name))
	    break;
	++i;
      }
    
    if (i == MAX_NAMES) 
      {
        reply->replycode = NOT_FOUND;
	return;
      }
    reply->replycode = OK;
      
    if ( Table[i].name[0] == 0 ) 
        if(force)
	    i = CreateCalendar( Table, msg, id, name );
	else
	  {
	    reply->replycode = NOT_FOUND;
	    return;
	  }

    if ( i > MAX_NAMES )
        return;
    
    Table[i].inUse = id;
    Table[i].lastDateRead = 0;
    Table[i].filein = fopen(Table[i].filename,"r");
    Table[i].fileout = fopen(Table[i].filename,"a");
    /* WARNING: This doesn't work if the file server
	obeys I/O protocol's defined semantics for
	independence of instances */

    reply->fileid = i;
  }

