#include <Venviron.h>
#include <Vstorage.h>
#include <Vio.h>
#include <Vioprotocol.h>
#include <Vnaming.h>
#include <Vdirectory.h>
#include <Vstorage.h>

extern char * rindex() ;


static char DirSpace[512] ;

CreateDir( dirname )
    char *dirname ;
  {
    char *endp, *string, savech ;
    char *rargv[2] ;
    ArbitraryDescriptor *desc ;
    Message msg ;
    DescriptorRequest *drequest = (DescriptorRequest *) msg ;
    DescriptorReply *dreply = (DescriptorReply *) msg ;
    FSRequest   *request = (FSRequest *) msg ;
    FSReply     *reply = (FSReply *) msg;
    ProcessId pid ;
    SystemCode error ;
    File *processFile[2] ;
    char c;

    if( FileType( dirname ) )
        return( DUPLICATE_NAME ) ;

        /* game plan: first find out if unix dir or storage dir
	 *            if storage dir we create the file         
	 *            else we  fexecute  mkdir in given context
	 */

    DirSpace[511] = '\0' ;
    desc = (ArbitraryDescriptor *) DirSpace ;
    string = (char *) desc + sizeof(ArbitraryDescriptor) ;
    endp = rindex(dirname,'/' ) ;	/* strip of last part of file name */
    if( ! endp ) endp = rindex(dirname,']' ) ;
    if( endp ) 
      {
        savech = *endp ;
	*endp = '\0' ;
	strcpy( string, dirname ) ;
	*endp = savech ;
      }
    else /* "." */
      {
	strcpy( string, "." ) ;
      }
	
    drequest->requestcode = NREAD_DESCRIPTOR ;
    drequest->nameindex = sizeof( ArbitraryDescriptor ) ;
    drequest->fileid = 0 ;
    drequest->dataindex = 0 ;
    drequest->namecontextid = 0 ;
    drequest->segmentptr = DirSpace ;
    drequest->segmentlen = strlen( string )+sizeof(ArbitraryDescriptor) ;
	
    pid = NameSend( drequest ) ;

    if( drequest->requestcode != OK )
        return( drequest->requestcode ) ;
    /* pid now is server */
	
    switch ( desc->e.descriptortype )
      {	    
        case UNIXFILE_DESCRIPTOR:
	    /* setup fexecute cmd  by first copying context then fexecute */
	    endp = rindex( dirname, '[' ) ;
	    if( endp )
	      {
		endp = rindex( endp, ']' ) ;
		if( ! endp )
		    return( NOT_FOUND ) ;
		*endp = '\0' ;
		strcpy( string, dirname ) ;
		strcat( string, "]mkdir" ) ;
		*endp++ = ']' ;
	      }
	    else
	      {
	        strcpy( string, "mkdir" ) ;
		endp = dirname ;
	      }
	    rargv[0] = endp ;
	    rargv[1] = NULL ;
	    error = RemoteExecute( processFile, string, rargv, FREAD ) ;
	    if (!error)
	      {
		/* Wait for the remote command to complete: */
		while ((c = getc(processFile[0])) != EOF) {}
		if ((error = Eof(processFile[0])) == END_OF_FILE)
		    error = OK;
	      }
	    return error;


	case FILE_DESCRIPTOR:
	    request->requestcode = CREATE_FILE;
            request->arg1 = 0;  /* causes default perms to be father_perms*/
            request->filename = dirname ;
            request->filenamelen = strlen( dirname );
            request->filenameindex = 0;

            pid = NameSend( request );

	    return( reply->replycode ) ;


	default:
	    return( MODE_NOT_SUPPORTED ) ;
      }
  }


