#ifndef lint
static char sccsid[] = "@(#)config.c	1.8 (Berkeley) 8/11/83";
#endif

/*
 * This file contains definitions of network data used by Mail
 * when replying.  See also:  configdefs.h and optim.c
 */

/*
 * The subterfuge with CONFIGFILE is to keep cc from seeing the
 * external defintions in configdefs.h.
 */
#define	CONFIGFILE
#include "configdefs.h"

/*
 * Set of network separator characters.
 */
char	*metanet = "!^:%@.";

/*
 * Host table of "known" hosts.  See the comment in configdefs.h;
 * not all accessible hosts need be here (fortunately).
 */
struct netmach netmach[] = {
	"Shasta",	's',		BN|SN,
	"SU-SHASTA",	's',		BN|SN,
	"SU-SHASTA.ARPA",'s',		BN|SN,
	"diablo",	'd',		SN,
	"SU-DIABLO",	'd',		SN,
	"SU-AIMVAX",	'd',		SN,
	"SU-AIMVAX.ARPA",'d',		SN,
	"Helens",	'h',		SN,
	"Navajo",	'o',		SN,
	"SU-Navajo",	'o',		SN,
	"SU-NAVAJO.ARPA",'o',		SN,
	"Whitney",	'w',		SN,
	"SU-Whitney",	'w',		SN,
	"SU-WHITNEY.ARPA",'w',		SN,
	"ISL",		'i',		SN,
	"Tamalpais",	'i',		SN,
	"SU-ISL",	'i',		SN,
	"SU-ISL.ARPA",	'i',		SN,
	"DSN",		'n',		SN,
	"SU-DSN",	'n',		SN,
	"SU-DSN.ARPA",	'n',		SN,
	"Tahoma",	't',		SN,
	"Psych",	'p',		SN,
	"Sumex-Aim",	'a',		AN|SN,
	"SUMEX-AIM",	'a',		AN|SN,
	"SUMEX-AIM.ARPA",'a',		AN|SN,
	"Sail",		'l',		AN|SN,
	"SU-AI",	'l',		AN|SN,
	"SU-AI.ARPA",	'l',		AN|SN,
	"SU-Score",	'S',		AN|SN,
	"SU-Score.ARPA",'S',		AN|SN,
	"Score",	'S',		AN|SN,
	"research",	'R',		BN,
	"ucbvax",	'v',		BN,
	"ucb",		'v',		BN,
	"onyx",		'x',		BN,
	EMPTY,		EMPTYID,	SN,	/* Filled in dynamically */
	0,		0,		0
};

/*
 * Table of ordered of preferred networks.  You probably won't need
 * to fuss with this unless you add a new network character (foolishly).
 */
struct netorder netorder[] = {
	AN,	'@',
	AN,	'%',
	BN,	'!',
	-1,	0
};

/*
 * Table to convert from network separator code in address to network
 * bit map kind.  With this transformation, we can deal with more than
 * one character having the same meaning easily.
 */
struct ntypetab ntypetab[] = {
	'%',	AN,
	'@',	AN,
	'!',	BN,
	0,	0
};

struct nkindtab nkindtab[] = {
	AN,	IMPLICIT,
	BN,	EXPLICIT,
	SN,	IMPLICIT,
	0,	0
};
