#include <Venviron.h>
#include <Vioprotocol.h>
#include <Vdirectory.h>
#include <Vio.h>
#include "sh.h"

DirList *ReadDirectory(path)
char *path;
/*
 * Return a sorted linked list of the names of the entries
 * in the directory 'path'.
 */
  {
    SystemCode error; 
    DirList *entrylist, *e1, *e2;
    File *dir;
    ArbitraryDescriptor desc;
    char *malloc(), *DescriptorName(), *n;
   
    entrylist = 0;
    dir = Open(path, FREAD|FDIRECTORY|FBLOCK_MODE, &error);
    if (!error)
      {
        for (dir->block = 0; dir->lastexception == OK; dir->block++)
          {
            if (Read(dir, &desc, dir->blocksize) != dir->blocksize)
              {
                if (dir->lastexception == END_OF_FILE) break;
                FreeDirList(entrylist);
                fprintf(stderr, "Error reading directory '%s'.\n", path);
                return(0);
              }
            if (!(n = DescriptorName(&desc))) continue;
            e1 = (DirList *) malloc(sizeof(DirList));
            e1->link = 0;
	    e1->fn = malloc(strlen(n));
	    strcpy(e1->fn, n);
            if (!entrylist)
                entrylist = e1;
	    else
                sortedinsert(entrylist, e1);
           }
        Close(dir);
      }
    return(entrylist);
  }

FreeDirList(head)
DirList *head;
  {
    DirList *p;
    p = head;
    while (head)
      {
        p = head->link;
        free(head);
        head = p;
      }
  }

sortedinsert(head, rec)
  DirList *head, *rec;
  {
    DirList *e2;
    char *s;
    e2 = head;
    while (e2)
      {
        if (strcmp(rec->fn, e2->fn) < 1)
          {
	    rec->link = e2->link;
	    e2->link = rec;
	    s = rec->fn;
	    rec->fn = e2->fn;
	    e2->fn = s;
	    e2 = 0;
	  }
	else if (!e2->link)
	  {
	    e2->link = rec;
	    e2=0;
	  }
        else e2=e2->link;
      }
  }

