#include <Venviron.h>
#include <Vgts.h>
#include <Vio.h>


#define PN 0
#define PH 10
#define PV 0


short Pvgt, Psdf ;
char Name[256];


main()
  {
    procwatch() ;
  }

watch()
  {
    Message msg ;
    
    while (1)
        Receive (msg) ;
  }


procwatch()
  {
    float proc[75] ;
    int i ;
    ProcessId  watchpid ;
    int watch() ;
    SystemCode QueryWorkstationConfig();
    short font = DefineFont("Helvetica7", NULL ) ;
    short titlefont = DefineFont("Clarity12", NULL);

    if (QueryWorkstationConfig("name", Name, 80) != OK)
        strcpy(Name, "Status");
    strcat(Name, "                                                         ") ;
    strcat(Name, "                                                         ") ;
    /* catch break */
    watchpid = Create (100, watch, 512) ;
    Ready (watchpid, 0) ;
    SetBreakProcess (stdin, watchpid) ;


    font = DefineFont("Helvetica7", NULL ) ;
    
    Psdf = CreateSDF() ;
    DefineSymbol (Psdf, PN+1, "Status") ;
    
    AddItem(Psdf, PN+2,  PH+10, PH+160, PV+15, PV+16, 
              0, SDF_HORIZONTAL_LINE, NULL) ;
    AddItem(Psdf, PN+3,  PH+10, PH+160, PV+65, PV+66, 
              0, SDF_HORIZONTAL_LINE, NULL) ;
    AddItem(Psdf, PN+4,  PH+10, PH+160, PV+115, PV+116, 
              0, SDF_HORIZONTAL_LINE, NULL) ;
    AddItem(Psdf, PN+5,  PH+3, PH+15, PV+12, PV+17, 
                 font, SDF_TEXT, "0") ;
    AddItem(Psdf, PN+6,  PH-3, PH+10, PV+62, PV+67,
                  font, SDF_TEXT, "50") ;
    AddItem(Psdf, PN+7,  PH-8, PH+5, PV+112, PV+117, 
                 font, SDF_TEXT, "100") ;
    AddItem(Psdf, PN+8, PH+10, PH+11, PV+12, PV+15, 
              0, SDF_VERTICAL_LINE, NULL) ;
    AddItem(Psdf, PN+9, PH+60, PH+61, PV+12, PV+15, 
              0, SDF_VERTICAL_LINE, NULL) ;
    AddItem(Psdf, PN+10, PH+110,PH+111, PV+12, PV+15, 
              0, SDF_VERTICAL_LINE, NULL) ;
    AddItem(Psdf, PN+11, PH+160,PH+161, PV+12, PV+15, 
              0, SDF_VERTICAL_LINE, NULL) ;
    AddItem(Psdf, PN+12, PH+50, PH+61, PV+3, PV+10, 
                  font, SDF_TEXT, "-10") ;
    AddItem(Psdf, PN+13, PH+105,PH+116, PV+3, PV+10, 
                  font, SDF_TEXT, "-5") ;
    AddItem(Psdf, PN+14, PH+20, PH+50, PV+120, PV+125,
    		  titlefont, SDF_TEXT, "Processor");
    for (i=0; i<75; i++)
      {
        proc[i] = 0 ;
	AddItem(Psdf, PN+20+i, PH+10+i*2, PH+11+i*2, PV+15, 
	   (int) (PV+15+proc[i]), 0, SDF_VERTICAL_LINE, NULL) ;
      }
    
    EndSymbol(Psdf, PN+1,0) ;
    
    Pvgt = CreateVGT(Psdf, GRAPHICS+ZOOMABLE, PN+1, "   Processor Usage    ") ;

    CreateView(  (int) Pvgt, 
    		  (short) 0, 		/*  sxmin          */
		  (short) 5,  		/*  symin          */
		  (short) 180,  	/*  sxmax          */
		  (short) 5+160,  	/*  symax          */
		  (short) 0,  		/*  wxmin          */
		  (short) 0,  		/*  wymin          */
		  (char) 0, 0) ; 	/*  zoom, showgrid */

    
    GetIdleTimeCount() ;
    while (1)
      {
        for (i=0; i<70; i++)
	  proc[i] = proc[i+5] ;
	for (i=0; i<5; i++)
	  {
	   if (! ValidPid(watchpid))
	         Quit() ;
	    sleep(12) ;
	    proc[70+i] = 100 - GetIdleTimeCount() ;
	  }
	EditSymbol(Psdf, PN+1) ;
        for (i=0; i<75; i++)
          {
 	    ChangeItem(Psdf, PN+20+i, PH+10+i*2, PH+11+i*2, PV+15, 
	        (int) (PV+15+proc[i]), 0, SDF_VERTICAL_LINE, NULL) ;
	    DeleteItem(Psdf, 20+i) ;
          }
	EndSymbol(Psdf, PN+1, Pvgt) ;
      }
  }


Quit()
  {
	  DeleteVGT(Pvgt, 1) ;
	  DeleteSDF(Psdf) ;
	  exit( 0 ) ;
  }

GetIdleTimeCount()
  {
    unsigned newcount, newsecs, newticks  ;
    static unsigned oldcount, oldsecs, oldticks = 0 ;
    unsigned secs, ticks, count ;
    float factor ;
    static ProcessId idleprocess = 0 ;
    SystemCode QueryProcessorUsage( ) ;

    if (idleprocess == 0)
        idleprocess = Creator(0) & 0xFFFF0000 ;
    
    QueryProcessorUsage (idleprocess, &newcount, 0) ; 
    newsecs = GetTime(&newticks) ;
    /* do arithmetic in ticks and compute CurrentIdleTime as
     * counts per minute */
    if (newcount >= oldcount)
        count = newcount - oldcount ;
    else
        count = newcount + (0xFFFFFFFF - oldcount) ;
    if (newsecs >= oldsecs)
        secs = newsecs - oldsecs ;
    else
        secs = newsecs + (0xFFFFFFFF - oldsecs) ;
    if (newticks < oldticks)
      {
        secs++ ;
	ticks = newticks - oldticks + CLICKS_PER_SEC ;
      }
    else
        ticks = newticks - oldticks ;  
    factor = 100 / (secs*100.0 + ticks) ;
    factor = factor * count ;
    oldsecs = newsecs ;
    oldticks = newticks ;
    oldcount = newcount ;
    return (factor) ;
  }

