@string(LastEditDate="Tue Jun 17 17:04:43 1986")
@comment(Current maintainer: Keith Lantz)

@string(ManualTitle="V-System 6.0 Reference Manual")
@string(Authors="V-System Development Group")

@libraryfile(manual)

@comment( *** KAL -- 7/27/85
	All the magic with pageheading and footing placement is because
	Scribe is somewhat stupid.  When Scribing a piece of a document
	via "parts" and "roots", commands in the root file will only
	be read up to point where the first text is generated.  Therefore,
	the "part" will end up with the style settings -- including page
	headings and footings -- in effect at the time the first text
	is generated.  In this case, the first text is generated within
	titlepage.mss, which has no headings OR footings; in short,
	totally wrong for what we want to do.  So, here we place the
	@page- commands that we want in effect for the "body" of the
	document, and then we have to play with those settings in/for each
	of the preface, the titlepage, the introduction, etc.  Blech,
	barf, gag, but it works.
    ***)

@pageheading(odd, left="@bsbf[@title(Section)]",
	right="@bsbf[@value(page)]")
@pageheading(even, left="@bsbf[@value(page)]",
	right="@bsbf[@title(Chapter)]")
@pagefooting(odd, left="@bsbf[@title(MajorPart)]",
	right="@bsbf[@value(FileDate)]")
@pagefooting(even, left="@bsbf[@value(FileDate)]",
	right="@bsbf[@value(ManualTitle)]")

@include(titlepage)

@comment( Headings and footings were turned off INSIDE titlepage.mss! )

@pageheading(odd, left="@bsbf[@title(Section)]",
	right="@bsbf[@value(page)]")
@pageheading(even, left="@bsbf[@value(page)]",
	right="@bsbf[@title(Section)]")
@pagefooting(left="@bsbf[@value(ManualTitle)]",
	right="@bsbf[@value(FileDate)]")
@modify(page, numbered "@i")
@set(page=3)
@newpage
@include(preface)
@string(lastprecontentspage=page)

@pageheading(odd, left="@bsbf[@title(Section)]",
	right="@bsbf[@value(page)]")
@pageheading(even, left="@bsbf[@value(page)]",
	right="@bsbf[@title(Chapter)]")
@modify(page, numbered "@#@:-@1")
@newpage
@include(intro)

@pageheading()
@pagefooting()
@np
@MajorPart(Using V)
@pageheading(odd, left="@bsbf[@title(Section)]",
	right="@bsbf[@value(page)]")
@pageheading(even, left="@bsbf[@value(page)]",
	right="@bsbf[@title(Chapter)]")
@pagefooting(odd, left="@bsbf[@title(MajorPart)]",
	right="@bsbf[@value(FileDate)]")
@pagefooting(even, left="@bsbf[@value(FileDate)]",
	right="@bsbf[@value(ManualTitle)]")

@np
@include(cmds/overview)
@np
@include(cmds/exec)
@np
@Include(cmds/cmds)
@np
@include(cmds/amaze)
@np
@include(cmds/checkers)
@np
@include(cmds/bits)
@np
@include(cmds/build)
@np
@Include(cmds/debug)
@np
@include(cmds/draw)
@np
@include(cmds/fscheck)
@np
@include(cmds/hack)
@np
@include(cmds/siledit)
@np
@include(cmds/timeipc)
@np
@Include(cmds/ved)
@np
@include(cmds/xlisp)
@np
@include(cmds/standalone)

@pageheading()
@pagefooting()
@np
@MajorPart(V Programming)
@pageheading(odd, left="@bsbf[@title(Section)]",
	right="@bsbf[@value(page)]")
@pageheading(even, left="@bsbf[@value(page)]",
	right="@bsbf[@title(Chapter)]")
@pagefooting(odd, left="@bsbf[@title(MajorPart)]",
	right="@bsbf[@value(FileDate)]")
@pagefooting(even, right="@bsbf[@value(FileDate)]",
	right="@bsbf[@value(ManualTitle)]")

@np
@Include(libc/overview)
@np
@Include(libc/mechanics)
@np
@Include(libc/config)
@np
@include(libc/execctl)
@np
@include(libc/fields)
@np
@Include(libc/io)
@np
@include(libc/locking)
@np
@Include(libc/mem)
@np
@include(libc/naming)
@np
@Include(libc/numeric)
@np
@Include(libc/process)
@np
@include(libc/pgmexec)
@np
@comment{@include(libc/service) **removed**
@np}
@include(libc/vgts)
@np
@comment{@include(libc/emt) **removed**
@np}
@Include(libc/others)

@pageheading()
@pagefooting()
@np
@MajorPart(V Servers)
@pageheading(odd, left="@bsbf[@title(Section)]",
	right="@bsbf[@value(page)]")
@pageheading(even, left="@bsbf[@value(page)]",
	right="@bsbf[@title(Chapter)]")
@pagefooting(odd, left="@bsbf[@title(MajorPart)]",
	right="@bsbf[@value(FileDate)]")
@pagefooting(even, right="@bsbf[@value(FileDate)]",
	right="@bsbf[@value(ManualTitle)]")

@np
@Include(servers/overview)
@np
@include(servers/messages)
@np
@include(servers/ioprotocol)
@np
@include(servers/naming)
@np
@Include(servers/auth)
@np
@Include(servers/devices)
@np
@Include(servers/exceptions)
@np
@include(servers/exec)
@np
@Include(servers/internet)
@np
@include(servers/mem)
@np
@include(servers/pipe)
@np
@include(servers/storage)
@np
@include(servers/team)
@np
@Include(servers/unix)
@comment{
@np
@include(servers/service) **removed**}
@np
@include(servers/termagent)
@np
@include(servers/sts)
@np
@Include(servers/vgts)

@begin(comment)
@MajorPart(Kernel)
@chapter(Kernel Overview)
@label(Koverview)
@Include(kernel/overview.body)
@include(kernel/operations.mss)
@Include(kernel/exceptions)
@Include(kernel/perform)
@Include(kernel/internals)
@Include(kernel/maintain)
@end(comment)

@modify(page, within appendix, numbered "@#@:-@1", referenced "@#@:-@1")

@pageheading()
@pagefooting()
@np
@MajorPart(Appendices)
@pageheading(odd, left="@bsbf[@title(Section)]",
	right="@bsbf[@value(page)]")
@pageheading(even, left="@bsbf[@value(page)]",
	right="@bsbf[@title(Chapter)]")
@pagefooting(odd, left="@bsbf[@title(MajorPart)]",
	right="@bsbf[@value(FileDate)]")
@pagefooting(even, left="@bsbf[@value(FileDate)]",
	right="@bsbf[@value(ManualTitle)]")

@np
@include(biblio)
@np
@include(libc/style)
@np
@include(install/install)
@np
@include(libc/index)

@comment[For index, table of contents, etc.:]
@pageheading(odd, left="@bsbf[@title(Section)]",
	right="@bsbf[@value(page)]", immediate)
@pageheading(even, left="@bsbf[@value(page)]",
	right="@bsbf[@title(section)]")
@pagefooting(left="@bsbf[@value(ManualTitle)]",
	right="@bsbf[@value(date)]")
@set(page=0)
@modify(page, numbered "Index-@1")

