/************************************************************************/
/*									*/
/*			(C) COPYRIGHT 1985				*/
/*			BOARD OF TRUSTEES				*/
/*			LELAND STANFORD JUNIOR UNIVERSITY		*/
/*			STANFORD, CA. 94305, U.S.A.			*/
/*									*/
/************************************************************************/

/*
 * Routines to select hosts for remote execution.
 *
 * Marvin Theimer
 */


#include <Venviron.h>
#include "Vteams.h"

extern int QueryHostsViaMulticast();




/*
 * QueryHosts:
 * Returns descriptor records for hosts selected in descArray 
 * which meet the selection criteria specified.  At most numHosts 
 * selections are returned.  
 * The number of hosts actually selected is returned as the funtion
 * value.
 */

int QueryHosts(spec, descArray, numHosts, error)
    SelectionRec *spec;	/* Host selection spec. */
    SelectionRec *descArray;
			/* Array for returning descriptors of selected 
			   hosts. */
    int numHosts;	/* Maximum number of selections to return.
			   Also the size of pidArray. */
    SystemCode *error;	/* Status code. */
  {
    return(QueryHostsViaMulticast(spec, descArray, numHosts, error));
  }
