/* Minimal declarations for Q-compatible structures
   Per Bothner. February 1985.
 */
#ifndef _Q_TYPES
#define _Q_TYPES
typedef union ObUnion *Object;

/* special reference counts */
#define RefsNone 0
#define RefsOverflow (-1)
#define RefsInfinity (-2)

#ifdef MC68000
typedef struct TypeOb *
    HeapPrefix;
#define __RefsInfinity 0xFE000000	/* RefsInfinity << 24 */
#define __GenOffset 0x9E000000 /* TGeneral<<24 -- temporary magic */
#define __HeapPrefix(type) (struct TypeOb*)((long)(type)+__RefsInfinity-__GenOffset)
#define __optionField unsigned short options;
#define Options(x) (x).options
#define __Opts_Type(opts, type) (opts), __HeapPrefix(type)
#else
typedef struct {
    short options;
    short refCount;
    struct TypeOb *type;
  } HeapPrefix;
#define __HeapPrefix(type) __Opts_Type(0, type)
#define __optionField /* use type.options instead */
#define Options(x) (x).type.options
#define __Opts_Type(opts, type) { 0, RefsInfinity, (struct TypeOb*)(type) }
#endif
#endif _Q_TYPES
