/********************************************************/
/*		(C) COPYRIGHT 1983			*/
/*		BOARD OF TRUSTEES			*/
/*	LELAND STANFORD JUNIOR UNIVERSITY		*/
/*	  STANFORD, CA. 94305, U. S. A.			*/
/********************************************************/

/* Vmodyfypad.h - Mode bits for ModifyPad and SetMode
 *
 * Kenneth Brooks, December 1983
 *    derived from keytable.h and Vgts.h
 *
 * Gus Fernandez, March 1986
 *    split from VTermAgent.h
 *
 */

#ifndef VMODIFYPAD
#define VMODIFYPAD

/* standard ModifyPad bits */

/** CAUTION!!  Must not overlap with ModifyPad bits in Vgts.h!! */

# define CR_Input 1		/* change CR to LF on input */
# define LF_Output 2		/* change LF to CRLF on output */
# define Echo 4			/* echo input characters */
# define LineBuffer 8		/* Buffer up each line before returning */
# define PageOutput 2048	/* Wait for user after each screenful */

# define PageOutputEnable 4096	/* Interpret the PageOutput bit as a sticky */
				/* enable/disable bit for PageOutput.	    */
				/* Query returns value of enable bit in	    */
				/* this position.			    */

# define DiscardOutput 8192	/* Discard all output to this pad.  Gets    */
				/* turned on when user types 'q' when	    */
				/* output is blocked at end of page.  Gets  */
				/* turned off when next input is sent       */
				/* to the client, or may be turned off      */
				/* manually via ModifyPad.		    */


#endif VMODIFYPAD
