/*
 * V-System Pipe Server
 * CopyRight (c) 1981 David Cheriton, all rights reserved.
 * transliterated from Verex and Zed. May 1983.
 */

#ifndef VPIPE

#define VPIPE

#include <Vio.h>

#define	PIPE_BLOCK_SIZE		1024

/* Structures defining the template structure of standard I/O request
 * and reply messages.
 */
typedef struct
  {
#ifndef LITTLE_ENDIAN
    SystemCode		requestcode;	/* CREATE_INSTANCE */
    short unsigned	filenameindex;	/* First byte of filename to use */
    short unsigned	type;		/* The type of file to create */
    short unsigned	filemode;
#else LITTLE_ENDIAN
    short unsigned	filenameindex;	/* First byte of filename to use */
    SystemCode		requestcode;	/* CREATE_INSTANCE */
    short unsigned	filemode;
    short unsigned	type;		/* The type of file to create */
#endif LITTLE_ENDIAN
    ProcessId		readowner;	/* Owner for the read end */
    ProcessId		writeowner;	/* Owner for the write end */
    unsigned		buffers;	/* Number of buffers allocated */
    ContextId		contextid;	/* Context used to interpret name */
    char		*filename;
    unsigned		filenamelen;
  } CreatePipeRequest;

#endif VPIPE
