/*
 * OpenIp
 * Opens an Ip connection instance with the internet server,
 *   and creates a File structure for it.
 *
 * Marvin Theimer, 8/83
 */

#include <Vioprotocol.h>
#include <Vnet.h>

File *OpenIp(prot, error)
    char prot;
    SystemCode *error;
{
  Message m;
  CreateInstanceRequest *msg = (CreateInstanceRequest *) m;
  ProcessId netPid;
  IpParms *ct;

  netPid = GetPid(INTERNET_SERVER, ANY_PID);
  msg->requestcode = CREATE_INSTANCE;
  msg->filenameindex = 0;
  msg->filename = "Ip";
  msg->filenamelen = 2;
  msg->type = IPtype;

  ct = (IpParms *) (msg->unspecified);
  ct->protocol = prot;

  return(_Open(msg, FCREATE|FBLOCK_MODE|FRELEASE_ON_CLOSE, netPid, error) );
}
