/*
 * V Kernel I/O - Copyright (c) 1982 by David Cheriton
 * (Transliterated from Zed and Verex I/O system)
 *
 * SeekBlock
 */
#include "Vio.h"

SystemCode SeekBlock( file, offset, origin )
    register File *file; int offset, origin;

  /* Seek to the block number speified by the origin and offset. */
  {
    if( !(file->type & FBLOCK_MODE ) )
        abort("SeekBlock: not block mode file");

     switch( origin )
      {
	case FILE_BEGINNING: file->block = offset; break;

	case FILE_END: file->block = file->lastblock; break;

	case FILE_CURRENT_POS: file->block += offset; break;

	default: abort( "SeekBlock: origin" );
      }
    return( OK );
  }
